<?php
################################################################################
# @Name : ./admin/users/add.php
# @Description : add user
# @Call : /admin/user.php
# @Parameters : 
# @Author : Flox
# @Create : 17/09/2021
# @Update : 17/09/2021
# @Version : 3.2.16
################################################################################


if($_POST['add'] && $rright['admin'])
{
	if(!$_POST['password']) {$error=T_('Vous devez spécifier un mot de passe');}
	if(!$_POST['login']) {$error=T_('Vous devez spécifier un identifiant');}
	if($_POST['password']!=$_POST['password2']) {$error=T_('Les mots de passe ne sont pas identiques');}
	if($_POST['mail'])
	{
		//email check
		if($_POST['mail'])
		{
			if(!strpos($_POST['mail'],'.')) {$error=T_("l'adresse mail doit posséder un point");}
			if(strpos($_POST['mail'],'@'))
			{
				$mail_domain=explode('@',$_POST['mail']);
				if(!strpos($mail_domain[1],'.')) {$error=T_("Le domaine de l'adresse mail doit posséder un point");}
			} else {$error=T_("l'adresse mail doit posséder un arobase");}
		}
	}
	if($_POST['login'])
	{
		$qry=$db->prepare("SELECT `id` FROM `tusers` WHERE `login`=:login AND `disable`='0'");
		$qry->execute(array('login' => $_POST['login']));
		$row=$qry->fetch();
		$qry->closeCursor();
		
		if($row) {$error=T_('Un autre compte utilise déjà cet identifiant');}
	}
	//password policy
	if($rparameters['user_password_policy'] && $_POST['password'])
	{
		if(strlen($_POST['password'])<$rparameters['user_password_policy_min_lenght'])
		{
			$error=T_('Le mot de passe doit faire').' '.$rparameters['user_password_policy_min_lenght'].' '.T_('caractères minimum');
		}elseif($rparameters['user_password_policy_special_char'] && !preg_match('/[^a-zA-Z\d]/', $_POST['password']))
		{
			$error=T_('Le mot de passe doit contenir un caractère spécial');
		}elseif($rparameters['user_password_policy_min_maj'] && (!preg_match('/[A-Z]/', $_POST['password']) || !preg_match('/[a-z]/', $_POST['password'])))
		{
			$error=T_('Le mot de passe doit au moins une lettre majuscule et une minuscule');
		}
	}
	
	if(!$error)
	{
		//hash password
		$hash = password_hash($_POST['password'], PASSWORD_DEFAULT);
		
		$qry=$db->prepare("
		INSERT INTO tusers (
		`firstname`,
		`lastname`,
		`password`,
		`mail`,
		`phone`,
		`mobile`,
		`fax`,
		`company`,
		`address1`,
		`address2`,
		`zip`,
		`city`,
		`custom1`,
		`custom2`,
		`profile`,
		`login`,
		`chgpwd`,
		`last_pwd_chg`,
		`skin`,
		`function`
		) VALUES (
		:firstname,
		:lastname,
		:password,
		:mail,
		:phone,
		:mobile,
		:fax,
		:company,
		:address1,
		:address2,
		:zip,
		:city,
		:custom1,
		:custom2,
		:profile,
		:login,
		:chgpwd,
		:last_pwd_chg,
		:skin,
		:function
		)");
		$qry->execute(array(
			'firstname' => $_POST['firstname'],
			'lastname' => $_POST['lastname'],
			'password' => $hash,
			'mail' => $_POST['mail'],
			'phone' => $_POST['phone'],
			'mobile' => $_POST['mobile'],
			'fax' => $_POST['fax'],
			'company' => $_POST['company'],
			'address1' => $_POST['address1'],
			'address2' => $_POST['address2'],
			'zip' => $_POST['zip'],
			'city' => $_POST['city'],
			'custom1' => $_POST['custom1'],
			'custom2' => $_POST['custom2'],
			'profile' => $_POST['profile'],
			'login' => $_POST['login'],
			'chgpwd' => $_POST['chgpwd'],
			'last_pwd_chg' => date('Y-m-d'),
			'skin' => $_POST['skin'],
			'function' => $_POST['function']
			));
		$last_user_id=$db->lastInsertId();
		//if post service insert new assoc
		if($_POST['service'])
		{
			$qry=$db->prepare("INSERT INTO `tusers_services` (`user_id`,`service_id`) VALUES (:user_id,:service_id)");
			$qry->execute(array('user_id' => $last_user_id,'service_id' => $_POST['service']));
		}
		if($rparameters['user_agency'])
		{
			if($_POST['agency']) //if post agency insert new assoc
			{
				$qry=$db->prepare("INSERT INTO `tusers_agencies` (`user_id`,`agency_id`) VALUES (:user_id,:agency_id)");
				$qry->execute(array('user_id' => $last_user_id,'agency_id' => $_POST['agency']));
			}
		}
		if($rparameters['log'] && $_POST['profile']==4)
		{
			require_once('core/functions.php');
			logit('security', 'Admin account has been added '.$_POST['login'],$_SESSION['user_id']);
		}
		//redirect
		$www = "./index.php?page=admin&subpage=user";
		echo '<script language="Javascript">
		<!--
		document.location.replace("'.$www.'");
		// -->
		</script>';
	} else {
        echo '
            <div role="alert" class="alert alert-lg bgc-danger-l3 border-0 border-l-4 brc-danger-m1 mt-4 mb-3 pr-3 d-flex">
                <div class="flex-grow-1">
                    <i class="fas fa-times mr-1 text-120 text-danger-m1"><!----></i>
                    <strong class="text-danger">'.T_('Erreur').' : '.$error.'.</strong>
                </div>
                <button type="button" class="close align-self-start" data-dismiss="alert" aria-label="Close">
                    <span aria-hidden="true"><i class="fa fa-times text-80"><!----></i></span>
                </button>
            </div>
        ';
    }
}


if($_GET['action']=="add" && (($_SESSION['user_id']==$_GET['userid']) || $rright['admin']))
{
	//remove '' to display
	$_POST['firstname']=str_replace("'","",$_POST['firstname']);
	$_POST['lastname']=str_replace("'","",$_POST['lastname']);
	$_POST['login']=str_replace("'","",$_POST['login']);
	$_POST['password']=str_replace("'","",$_POST['password']);
	$_POST['mail']=str_replace("'","",$_POST['mail']);
	$_POST['phone']=str_replace("'","",$_POST['phone']);
	$_POST['mobile']=str_replace("'","",$_POST['mobile']);
	$_POST['fax']=str_replace("'","",$_POST['fax']);
	$_POST['function']=str_replace("'","",$_POST['function']);
	
	/////////////////////////////////////////////////////////////////////display add form///////////////////////////////////////////////////
	echo '
		<div class="col-12 cards-container">
			<div class="card bcard shadow">
				<div class="card-header">
					<h5 class="card-title">'.T_("Nouvel utilisateur").' :</h5>
					<span class="card-toolbar">
						<button title="'.T_('Ajouter un utilisateur').'" value="add" id="add" name="add" type="submit" form="1" class="btn btn-xs btn-success ml-1">
							<i class="fa fa-save text-110"><!----></i>
						</button>
					</span>
				</div>
				<div class="card-body">
					<div class="card-main no-padding">
						<form id="1" name="1" method="POST"  action="">
							<fieldset>
								<label for="firstname">'.T_('Prénom').' :</label>
								<input style="width:auto;" class="form-control form-control-sm d-inline-block" name="firstname" type="text" value="'.$_POST['firstname'].'" />
								<div class="space-4"></div>
								<label  for="lastname">'.T_('Nom').' :</label>
								<input style="width:auto;" class="form-control form-control-sm d-inline-block" name="lastname" type="text" value="'.$_POST['lastname'].'" />
								<div class="space-4"></div>
								<label for="login">'.T_('Identifiant').' :</label>
								<input style="width:auto;" class="form-control form-control-sm d-inline-block" autocomplete="off" name="login" type="text" value="'.$_POST['login'].'" />
								<div class="space-4"></div>
								<label  for="password">'.T_('Mot de passe').' :</label>
								<input style="width:auto;" class="form-control form-control-sm d-inline-block" autocomplete="new-password" name="password" type="password" value="'.$_POST['password'].'" />
								<div class="space-4"></div>
								<label  for="password2">'.T_('Confirmation mot de passe').' :</label>
								<input style="width:auto;" class="form-control form-control-sm d-inline-block" autocomplete="new-password" name="password2" type="password" value="'.$_POST['password2'].'" />
								<div class="space-4"></div>
								<label for="mail">'.T_('Adresse mail').' :</label>
								<input style="width:auto;" class="form-control form-control-sm d-inline-block" name="mail" type="text" value="'.$_POST['mail'].'" />
								<div class="space-4"></div>
								<label  for="phone">'.T_('Téléphone fixe').' :</label>
								<input style="width:auto;" class="form-control form-control-sm d-inline-block" name="phone" type="text" value="'.$_POST['phone'].'" />
								<div class="space-4"></div>
								<label  for="mobile">'.T_('Téléphone portable').' :</label>
								<input style="width:auto;" class="form-control form-control-sm d-inline-block" name="mobile" type="text" value="'.$_POST['mobile'].'" />
								<div class="space-4"></div>
								<label  for="fax">'.T_('Fax').' :</label>
								<input style="width:auto;" class="form-control form-control-sm d-inline-block" name="fax" type="text" value="'.$_POST['fax'].'" />
								<div class="space-4"></div>
								<label for="service">'.T_('Service').' :</label>
								<select style="width:auto;" class="form-control form-control-sm d-inline-block" name="service" '; if($rright['user_profil_service']==0) {echo 'disabled="disabled"';} echo '>
									<option value=""></option>';
									$qry = $db->prepare("SELECT `id`,`name` FROM `tservices` ORDER BY `name`");
									$qry->execute();
									while ($row = $qry->fetch()) 
									{
										if($_POST['service']) {echo '<option selected value="'.$row['id'].'">'.$row['name'].'</option>';} else {echo '<option value="'.$row['id'].'">'.$row['name'].'</option>';}
									} 
									$qry->closeCursor();
									echo '
								</select>
								';
								if($rparameters['user_agency'])
								{
									echo '
									<div class="space-4"></div>
									<label for="agency">'.T_('Agence').' :</label>
									<select style="width:auto;" class="form-control form-control-sm d-inline-block"  name="agency" '; if($rright['user_profil_agency']==0) {echo 'disabled="disabled"';} echo '>
										<option value=""></option>';
										$qry = $db->prepare("SELECT `id`,`name` FROM `tagencies` ORDER BY `name`");
										$qry->execute();
										while ($row = $qry->fetch()) 
										{
											if($_POST['agency']) {echo '<option selected value="'.$row['id'].'">'.$row['name'].'</option>';} else {echo '<option value="'.$row['id'].'">'.$row['name'].'</option>';}
										} 
										$qry->closeCursor();
										echo '
									</select>
									';
								}
								echo '
								<div class="space-4"></div>
								<label for="function">'.T_('Fonction').' :</label>
								<input style="width:auto;" class="form-control form-control-sm d-inline-block" name="function" type="text" value="'.$_POST['function'].'" />
								';
								//display advanced user informations
								if($rparameters['user_advanced']!='0')
								{
								echo '
									<div class="space-4"></div>
									<label  for="company">'.T_('Société').' :</label>
									<select style="width:150px;" class="chosen-select" data-placeholder=" " name="company" '; if($rright['user_profil_company']==0) {echo 'disabled="disabled"';} echo '>
    									<option value=""></option>';
										$qry = $db->prepare("SELECT `id`,`name` FROM `tcompany` ORDER BY `name`");
										$qry->execute();
    									while ($row = $qry->fetch()) 
    									{
    										if($user1['company']==$row['id']) echo "<option selected value=\"$row[id]\">$row[name]</option>"; else echo "<option value=\"$row[id]\">$row[name]</option>";
    									} 
										$qry->closeCursor(); 
    									echo '
							    	</select>
									
									<div class="space-4 pt-1"></div>
									<label for="address1">'.T_('Adresse').' 1 :</label>
									<input style="width:auto;" class="form-control form-control-sm d-inline-block" name="address1" type="text" value="" />
									<div class="space-4"></div>
									<label for="address2">'.T_('Adresse').' 2 :</label>
									<input style="width:auto;" class="form-control form-control-sm d-inline-block" name="address2" type="text" value="" />
									<div class="space-4"></div>
									<label for="city">'.T_('Ville').' :</label>
									<input style="width:auto;" class="form-control form-control-sm d-inline-block" name="city" type="text" value="" />
									<div class="space-4"></div>
									<label for="zip">'.T_('Code postal').' :</label>
									<input style="width:auto;" class="form-control form-control-sm d-inline-block" name="zip" type="text" value="" />
									<div class="space-4"></div>
									<label for="custom1">'.T_('Champ personnalisé').' 1 :</label>
									<input style="width:auto;" class="form-control form-control-sm d-inline-block" name="custom1" type="text" value="" />
									<div class="space-4"></div>
									<label for="custom2">'.T_('Champ personnalisé').' 2 :</label>
									<input style="width:auto;" class="form-control form-control-sm d-inline-block" name="custom2" type="text" value="" />
								';
								}
								//display theme selection
								echo '
								<hr />
								<label class="control-label bolder text-primary-m2" for="skin">'.T_('Thème').' :</label>
								<select style="width:auto;" class="form-control form-control-sm d-inline-block" name="skin">
									<option '; if($rparameters['default_skin']==''){echo "selected";} echo ' value="">'.T_('Bleu (Défaut)').'</option>
									<option '; if($rparameters['default_skin']=='skin-3'){echo "selected";} echo ' value="skin-3">'.T_('Gris').'</option>
									<option '; if($rparameters['default_skin']=='skin-1'){echo "selected";} echo ' value="skin-1">'.T_('Noir').'</option>
									<option '; if($rparameters['default_skin']=='skin-2'){echo "selected";} echo ' value="skin-2">'.T_('Violet').'</option>
									<option '; if($rparameters['default_skin']=='skin-5'){echo "selected";} echo ' value="skin-5">'.T_('Vert').'</option>
									<option '; if($rparameters['default_skin']=='skin-7'){echo "selected";} echo ' value="skin-7">'.T_('Vert et violet').'</option>
									<option '; if($rparameters['default_skin']=='skin-6'){echo "selected";} echo ' value="skin-6">'.T_('Orange').'</option>
									<option '; if($rparameters['default_skin']=='skin-8'){echo "selected";} echo ' value="skin-8">'.T_('Orange et violet').'</option>
									<option '; if($rparameters['default_skin']=='skin-4'){echo "selected";} echo ' value="skin-4">'.T_('Sombre').'</option>
								</select>
								';
								// Display profile list
								if($rright['admin_user_profile']!='0')
								{
									echo '
									<hr />
									<label class="control-label bolder text-primary-m2" for="profile">'.T_('Profil').' :</label>
									<div class="controls">
										<div class="radio">
											<label>
												<input type="radio" class="ace" name="profile" value="4"> <span class="lbl"> '.T_('Administrateur').' </span>
											</label>
										</div>
										<div class="radio">
											<label>
												<input type="radio" class="ace" name="profile" value="0"> <span class="lbl"> '.T_('Technicien').' </span>
											</label>
										</div>
										<div class="radio">
											<label>
												<input type="radio" class="ace" name="profile" value="3"> <span class="lbl"> '.T_('Superviseur').' </span>
											</label>
										</div>
										<div class="radio">
											<label>
												<input type="radio" class="ace" name="profile" value="1"> <span class="lbl"> '.T_('Utilisateur avec pouvoir').' </span>
											</label>
										</div>
										<div class="radio">
											<label>
												<input type="radio" class="ace" name="profile" checked value="2"> <span class="lbl"> '.T_('Utilisateur').' </span>
											</label>
										</div>
									</div>
									<hr />
									<label class="control-label bolder text-primary-m2" for="chgpwd">'.T_('Forcer le changement du mot de passe').' :</label>
									<div class="controls">
										<label>
											<input type="radio" class="ace" name="chgpwd" checked value="1"> <span class="lbl"> '.T_('Oui').' </span>
											<input type="radio" class="ace" name="chgpwd" value="0"> <span class="lbl"> '.T_('Non').' </span>
										</label>
									</div>
									';
								}
								else
								{
									echo '<input type="hidden" name="profile" value="">';
								}
								//display personal view
								if($rright['admin_user_view']!='0')
								{
									echo '
										<hr />
										<label class="control-label text-primary-m2" for="view">'.T_('Vues personnelles').' : <i class="fa fa-question-circle text-primary-m2" title="'.T_("associe des catégories à l'utilisateur").'"><!----><!----></i></label>
										<div class="controls">
											';
											//check if connected user have view
											$qry = $db->prepare("SELECT `id` FROM `tviews` WHERE uid=:uid");
											$qry->execute(array('uid' => $_GET['userid']));
											$row=$qry->fetch();
											$qry->closeCursor(); 
											if(!empty($row[0]))
											{
												//display actives views
												$qry = $db->prepare("SELECT * FROM `tviews` WHERE uid=:uid ORDER BY uid");
												$qry->execute(array('uid' => $_GET['userid']));
												while ($row = $qry->fetch())
												{
													$qry2 = $db->prepare("SELECT `name` FROM `tcategory` WHERE id=:id");
													$qry2->execute(array('id' => $row['category']));
													$cname=$qry2->fetch();
													$qry2->closeCursor(); 
													
													if($row['subcat']!=0)
													{
														$qry2 = $db->prepare("SELECT `name` FROM `tsubcat` WHERE id=:id");
														$qry2->execute(array('id' => $row['subcat']));
														$sname= $qry2->fetch();
														$qry2->closeCursor(); 
													} else {$sname='';}
													echo '- '.$row['name'].': ('.$cname['name'].' > '.$sname[0].') 
													<a title="'.T_('Supprimer cette vue').'" href="index.php?page=admin&amp;subpage=user&amp;action=edit&amp;userid='.$_GET['userid'].'&amp;viewid='.$row['id'].'&amp;deleteview=1"><img alt="delete" src="./images/delete.png" style="border-style: none" /></a>
													<br />';
												}
												$qry->closeCursor(); 
												echo '<br />';
											}
											//display add view form
											echo '
												'.T_('Catégorie').' :
												<select style="width:auto;" class="form-control form-control-sm d-inline-block" name="category" onchange="submit()" style="width:100px" >
													<option value="%"></option>';
													$qry = $db->prepare("SELECT `id`,`name` FROM `tcategory` ORDER BY name");
													$qry->execute();
													while ($row = $qry->fetch()) 
													{
														echo "<option value=\"$row[id]\">$row[name]</option>";
														if($_POST['category']==$row['id']) echo "<option selected value=\"$row[id]\">$row[name]</option>";
													} 
													$qry->closeCursor();
													echo '
												</select>
												<br />
												'.T_('Sous-catégorie').' :
												<select style="width:auto;" class="form-control form-control-sm d-inline-block mt-2" name="subcat" onchange="submit()" style="width:90px">
													<option value="%"></option>';
													if($_POST['category']!='%')
													{
														$qry = $db->prepare("SELECT `id`,`name` FROM `tsubcat` WHERE cat=:cat ORDER BY `name`");
														$qry->execute(array('cat' => $_POST['category']));
													}
													else
													{
														$qry = $db->prepare("SELECT `id`,`name` FROM `tsubcat` ORDER BY `name`");
														$qry->execute();
													}
													while ($row = $qry->fetch())
													{
														echo "<option value=\"$row[id]\">$row[name]</option>";
														if($_POST['subcat']==$row['id']) echo "<option selected value=\"$row[id]\">$row[name]</option>";
													} 
													$qry->closeCursor();
													echo '
												</select>
												<br />
												'.T_('Nom').' : <input style="width:auto;" class="form-control form-control-sm d-inline-block mt-2" autocomplete="off" name="viewname" type="text" value="'.$_POST['name'].'" size="20" />
										</div>';
								}
								echo'
							</fieldset>
							<div class="border-t-1 brc-secondary-l1 bgc-secondary-l3 py-3 text-center mt-5">
								<button title="'.T_('CTRL+S').'" value="add" id="add" name="add" type="submit" class="btn btn-success mr-2">
									<i class="fa fa-check"><!----></i>
									'.T_('Ajouter').'
								</button>
								<button name="cancel" value="cancel" type="submit" class="btn btn-danger" >
									<i class="fa fa-reply"><!----></i>
									'.T_('Retour').'
								</button>
							</div>
						</form>
					</div>
				</div>
			</div>
		</div>
	';
}
?>